//CPU disassemble

#ifndef __XATREMU_CPU8040__
#define __XATREMU_CPU8040__

namespace xatremu
{
class CPU8040
{
public:
	CPU8040();
	~CPU8040();
	//disassemble next instruction in program memory
	void DisAsmNextInstruction();

private:
	//table with instruction emulation subroutines
	typedef void (CPU8040::* CPUFunc)(void);
	CPUFunc CPUFuncTable[256];
#if 0==1
	= {
		//00-0f
		I_NOP, I_AJMP_CODE, I_LJMP_CODE, I_RR_A,
		I_INC_A, I_INC_DATA, I_INC_AT_R0, I_INC_AT_R1,
		I_INC_R0, I_INC_R1, I_INC_R2, I_INC_R3,
		I_INC_R4, I_INC_R5, I_INC_R6, I_INC_R7,

		//10-1f
		I_JBC_BIT_CODE, I_ACALL_CODE, I_LCALL_CODE, I_RRC_A,
		I_DEC_A, I_DEC_DATA, I_DEC_AT_R0, I_DEC_AT_R1,
		I_DEC_R0, I_DEC_R1, I_DEC_R2, I_DEC_R3,
		I_DEC_R4, I_DEC_R5, I_DEC_R6, I_DEC_R7,

		//20-2f
		I_JB_BIT_CODE, I_AJMP_CODE, I_RET, I_RL_A,
		I_ADD_A_IMM, I_ADD_A_DATA, I_ADD_A_AT_R0, I_ADD_A_AT_R1,
		I_ADD_A_R0, I_ADD_A_R1, I_ADD_A_R2, I_ADD_A_R3,
		I_ADD_A_R4, I_ADD_A_R5, I_ADD_A_R6, I_ADD_A_R7,

		//30-3f
		I_JNB_BIT_CODE, I_ACALL_CODE, I_RETI, I_RLC_A,
		I_ADDC_A_IMM, I_ADDC_A_DATA, I_ADDC_A_AT_R0, I_ADDC_A_AT_R1,
		I_ADDC_A_R0, I_ADDC_A_R1, I_ADDC_A_R2, I_ADDC_A_R3,
		I_ADDC_A_R4, I_ADDC_A_R5, I_ADDC_A_R6, I_ADDC_A_R7,

		//40-4f
		I_JC_CODE, I_AJMP_CODE, I_ORL_DATA_A, I_ORL_DATA_IMM,
		I_ORL_A_IMM, I_ORL_A_DATA, I_ORL_A_AT_R0, I_ORL_A_AT_R1,
		I_ORL_A_R0, I_ORL_A_R1, I_ORL_A_R2, I_ORL_A_R3,
		I_ORL_A_R4, I_ORL_A_R5, I_ORL_A_R6, I_ORL_A_R7,

		//50-5f
		I_JNC_CODE, I_ACALL_CODE, I_ANL_DATA_A, I_ANL_DATA_IMM,
		I_ANL_A_IMM, I_ANL_A_DATA, I_ANL_A_AT_R0, I_ANL_A_AT_R1,
		I_ANL_A_R0, I_ANL_A_R1, I_ANL_A_R2, I_ANL_A_R3,
		I_ANL_A_R4, I_ANL_A_R5, I_ANL_A_R6, I_ANL_A_R7,

		//60-6f
		I_JZ_CODE, I_AJMP_CODE, I_XRL_DATA_A, I_XRL_DATA_IMM,
		I_XRL_A_IMM, I_XRL_A_DATA, I_XRL_A_AT_R0, I_XRL_A_AT_R1,
		I_XRL_A_R0, I_XRL_A_R1, I_XRL_A_R2, I_XRL_A_R3,
		I_XRL_A_R4, I_XRL_A_R5, I_XRL_A_R6, I_XRL_A_R7,

		//70-7f
		I_JNZ_CODE, I_ACALL_CODE, I_ORL_C_BIT, I_JMP_AT_A_WITH_DPTR,
		I_MOV_A_IMM, I_MOV_DATA_IMM, I_MOV_AT_R0_IMM, I_MOV_AT_R1_IMM,
		I_MOV_R0_IMM, I_MOV_R1_IMM, I_MOV_R2_IMM, I_MOV_R3_IMM,
		I_MOV_R4_IMM, I_MOV_R5_IMM, I_MOV_R6_IMM, I_MOV_R7_IMM,

		//80-8f
		I_SJMP_CODE, I_AJMP_CODE, I_ANL_C_BIT, I_MOVC_A_AT_A_WITH_PC,
		I_DIV_AB, I_MOV_DATA_DATA, I_MOV_DATA_AT_R0, I_MOV_DATA_AT_R1,
		I_MOV_DATA_R0, I_MOV_DATA_R1, I_MOV_DATA_R2, I_MOV_DATA_R3,
		I_MOV_DATA_R4, I_MOV_DATA_R5, I_MOV_DATA_R6, I_MOV_DATA_R7,

		//90-9f
		I_MOV_DPTR_IMM, I_ACALL_CODE, I_MOV_BIT_C, I_MOVC_A_AT_A_WITH_DPTR,
		I_SUBB_A_IMM, I_SUBB_A_DATA, I_SUBB_A_AT_R0, I_SUBB_A_AT_R1,
		I_SUBB_A_R0, I_SUBB_A_R1, I_SUBB_A_R2, I_SUBB_A_R3,
		I_SUBB_A_R4, I_SUBB_A_R5, I_SUBB_A_R6, I_SUBB_A_R7,

		//a0-af
		I_ORL_C_SLBIT, I_AJMP_CODE, I_MOV_C_BIT, I_INC_DPTR,
		I_MUL_AB, I_RES, I_MOV_AT_R0_DATA, I_MOV_AT_R1_DATA,
		I_MOV_R0_DATA, I_MOV_R1_DATA, I_MOV_R2_DATA, I_MOV_R3_DATA,
		I_MOV_R4_DATA, I_MOV_R5_DATA, I_MOV_R6_DATA, I_MOV_R7_DATA,

		//b0-bf
		I_ANL_C_SLBIT, I_ACALL_CODE, I_CPL_BIT, I_CPL_C,
		I_CJNE_A_IMM_CODE, I_CJNE_A_DATA_CODE, I_CJNE_AT_R0_IMM_CODE, I_CJNE_AT_R1_IMM_CODE,
		I_CJNE_R0_IMM_CODE, I_CJNE_R1_IMM_CODE, I_CJNE_R2_IMM_CODE, I_CJNE_R3_IMM_CODE,
		I_CJNE_R4_IMM_CODE, I_CJNE_R5_IMM_CODE, I_CJNE_R6_IMM_CODE, I_CJNE_R7_IMM_CODE,

		//c0-cf
		I_PUSH_DATA, I_AJMP_CODE, I_CLR_BIT, I_CLR_C,
		I_SWAP_A, I_XCH_A_DATA, I_XCH_A_AT_R0, I_XCH_A_AT_R1,
		I_XCH_A_R0, I_XCH_A_R1, I_XCH_A_R2, I_XCH_A_R3,
		I_XCH_A_R4, I_XCH_A_R5, I_XCH_A_R6, I_XCH_A_R7,

		//d0-df
		I_POP_DATA, I_ACALL_CODE, I_SETB_BIT, I_SETB_C,
		I_DA_A, I_DJNZ_DATA_CODE, I_XCHD_A_AT_R0, I_XCHD_A_AT_R1,
		I_DJNZ_R0_CODE, I_DJNZ_R1_CODE, I_DJNZ_R2_CODE, I_DJNZ_R3_CODE,
		I_DJNZ_R4_CODE, I_DJNZ_R5_CODE, I_DJNZ_R6_CODE, I_DJNZ_R7_CODE,

		//e0-ef
		I_MOVX_A_AT_DPTR, I_AJMP_CODE, I_MOVX_A_AT_R0, I_MOVX_A_AT_R1,
		I_CLR_A, I_MOV_A_DATA, I_MOV_A_AT_R0, I_MOV_A_AT_R1,
		I_MOV_A_R0, I_MOV_A_R1, I_MOV_A_R2, I_MOV_A_R3,
		I_MOV_A_R4, I_MOV_A_R5, I_MOV_A_R6, I_MOV_A_R7,

		//f0-ff
		I_MOVX_AT_DPTR_A, I_ACALL_CODE, I_MOVX_AT_R0_A, I_MOVX_AT_R1_A,
		I_CPL_A, I_MOV_DATA_A, I_MOV_AT_R0_A, I_MOV_AT_R1_A,
		I_MOV_R0_A, I_MOV_R1_A, I_MOV_R2_A, I_MOV_R3_A,
		I_MOV_R4_A, I_MOV_R5_A, I_MOV_R6_A, I_MOV_R7_A
	}
#endif
private:
	unsigned short r_PC;
	//unsigned char r_R0, r_R1, r_R2, r_R3, r_R4, r_R5, r_R6, r_R7;
	//unsigned int64 totalCycles;
	//unsigned char r_A, r_B;
	//bool r_C;
	void *instrMemPtr;
	unsigned long ROMLen;

	void I_ACALL_CODE(void);
	void I_ADD_A_AT_R0(void);
	void I_ADD_A_AT_R1(void);
	void I_ADD_A_DATA(void); //ADD A,direct
	void I_ADD_A_IMM(void);
	void I_ADD_A_R0(void);
	void I_ADD_A_R1(void);
	void I_ADD_A_R2(void);
	void I_ADD_A_R3(void);
	void I_ADD_A_R4(void);
	void I_ADD_A_R5(void);
	void I_ADD_A_R6(void);
	void I_ADD_A_R7(void);
	void I_ADDC_A_AT_R0(void);
	void I_ADDC_A_AT_R1(void);
	void I_ADDC_A_DATA(void); //ADD A,direct
	void I_ADDC_A_IMM(void);
	void I_ADDC_A_R0(void);
	void I_ADDC_A_R1(void);
	void I_ADDC_A_R2(void);
	void I_ADDC_A_R3(void);
	void I_ADDC_A_R4(void);
	void I_ADDC_A_R5(void);
	void I_ADDC_A_R6(void);
	void I_ADDC_A_R7(void);
	void I_AJMP_CODE(void);
	void I_ANL_A_AT_R0(void);
	void I_ANL_A_AT_R1(void);
	void I_ANL_A_DATA(void); //ANL A,direct
	void I_ANL_A_IMM(void);
	void I_ANL_A_R0(void);
	void I_ANL_A_R1(void);
	void I_ANL_A_R2(void);
	void I_ANL_A_R3(void);
	void I_ANL_A_R4(void);
	void I_ANL_A_R5(void);
	void I_ANL_A_R6(void);
	void I_ANL_A_R7(void);
	void I_ANL_DATA_A(void); //ANL direct,A
	void I_ANL_DATA_IMM(void);
	void I_ANL_C_BIT(void);
	void I_ANL_C_SLBIT(void);
	void I_CJNE_A_DATA_CODE(void);
	void I_CJNE_A_IMM_CODE(void);
	void I_CJNE_R0_IMM_CODE(void);
	void I_CJNE_R1_IMM_CODE(void);
	void I_CJNE_R2_IMM_CODE(void);
	void I_CJNE_R3_IMM_CODE(void);
	void I_CJNE_R4_IMM_CODE(void);
	void I_CJNE_R5_IMM_CODE(void);
	void I_CJNE_R6_IMM_CODE(void);
	void I_CJNE_R7_IMM_CODE(void);
	void I_CJNE_AT_R0_IMM_CODE(void);
	void I_CJNE_AT_R1_IMM_CODE(void);
	void I_CLR_A(void);
	void I_CLR_BIT(void);
	void I_CLR_C(void);
	void I_CPL_A(void);
	void I_CPL_BIT(void);
	void I_CPL_C(void);
	void I_DA_A(void);
	void I_DEC_A(void);
	void I_DEC_AT_R0(void);
	void I_DEC_AT_R1(void);
	void I_DEC_DATA(void);
	void I_DEC_R0(void);
	void I_DEC_R1(void);
	void I_DEC_R2(void);
	void I_DEC_R3(void);
	void I_DEC_R4(void);
	void I_DEC_R5(void);
	void I_DEC_R6(void);
	void I_DEC_R7(void);
	void I_DIV_AB(void);
	void I_DJNZ_DATA_CODE(void);
	void I_DJNZ_R0_CODE(void);
	void I_DJNZ_R1_CODE(void);
	void I_DJNZ_R2_CODE(void);
	void I_DJNZ_R3_CODE(void);
	void I_DJNZ_R4_CODE(void);
	void I_DJNZ_R5_CODE(void);
	void I_DJNZ_R6_CODE(void);
	void I_DJNZ_R7_CODE(void);
	void I_INC_A(void);
	void I_INC_AT_R0(void);
	void I_INC_AT_R1(void);
	void I_INC_DATA(void);
	void I_INC_DPTR(void);
	void I_INC_R0(void);
	void I_INC_R1(void);
	void I_INC_R2(void);
	void I_INC_R3(void);
	void I_INC_R4(void);
	void I_INC_R5(void);
	void I_INC_R6(void);
	void I_INC_R7(void);
	void I_JB_BIT_CODE(void);
	void I_JBC_BIT_CODE(void);
	void I_JC_CODE(void);
	void I_JMP_AT_A_WITH_DPTR(void);
	void I_JNB_BIT_CODE(void);
	void I_JNC_CODE(void);
	void I_JNZ_CODE(void);
	void I_JZ_CODE(void);
	void I_LCALL_CODE(void);
	void I_LJMP_CODE(void);
	void I_MOV_A_IMM(void);
	void I_MOV_A_AT_R0(void);
	void I_MOV_A_AT_R1(void);
	void I_MOV_A_DATA(void);
	void I_MOV_A_R0(void);
	void I_MOV_A_R1(void);
	void I_MOV_A_R2(void);
	void I_MOV_A_R3(void);
	void I_MOV_A_R4(void);
	void I_MOV_A_R5(void);
	void I_MOV_A_R6(void);
	void I_MOV_A_R7(void);
	void I_MOV_AT_R0_A(void);
	void I_MOV_AT_R1_A(void);
	void I_MOV_AT_R0_DATA(void);
	void I_MOV_AT_R1_DATA(void);
	void I_MOV_AT_R0_IMM(void);
	void I_MOV_AT_R1_IMM(void);
	void I_MOV_BIT_C(void);
	void I_MOV_C_BIT(void);
	void I_MOV_DATA_A(void);
	void I_MOV_DATA_AT_R0(void);
	void I_MOV_DATA_AT_R1(void);
	void I_MOV_DATA_DATA(void);
	void I_MOV_DATA_IMM(void);
	void I_MOV_DATA_R0(void);
	void I_MOV_DATA_R1(void);
	void I_MOV_DATA_R2(void);
	void I_MOV_DATA_R3(void);
	void I_MOV_DATA_R4(void);
	void I_MOV_DATA_R5(void);
	void I_MOV_DATA_R6(void);
	void I_MOV_DATA_R7(void);
	void I_MOV_DPTR_IMM(void);
	void I_MOV_R0_A(void);
	void I_MOV_R1_A(void);
	void I_MOV_R2_A(void);
	void I_MOV_R3_A(void);
	void I_MOV_R4_A(void);
	void I_MOV_R5_A(void);
	void I_MOV_R6_A(void);
	void I_MOV_R7_A(void);
	void I_MOV_R0_DATA(void);
	void I_MOV_R1_DATA(void);
	void I_MOV_R2_DATA(void);
	void I_MOV_R3_DATA(void);
	void I_MOV_R4_DATA(void);
	void I_MOV_R5_DATA(void);
	void I_MOV_R6_DATA(void);
	void I_MOV_R7_DATA(void);
	void I_MOV_R0_IMM(void);
	void I_MOV_R1_IMM(void);
	void I_MOV_R2_IMM(void);
	void I_MOV_R3_IMM(void);
	void I_MOV_R4_IMM(void);
	void I_MOV_R5_IMM(void);
	void I_MOV_R6_IMM(void);
	void I_MOV_R7_IMM(void);
	void I_MOVC_A_AT_A_WITH_DPTR(void);
	void I_MOVC_A_AT_A_WITH_PC(void);
	void I_MOVX_A_AT_DPTR(void);
	void I_MOVX_A_AT_R0(void);
	void I_MOVX_A_AT_R1(void);
	void I_MOVX_AT_DPTR_A(void);
	void I_MOVX_AT_R0_A(void);
	void I_MOVX_AT_R1_A(void);
	void I_MUL_AB(void);
	void I_NOP(void);
	void I_ORL_A_AT_R0(void);
	void I_ORL_A_AT_R1(void);
	void I_ORL_A_DATA(void);
	void I_ORL_A_IMM(void);
	void I_ORL_A_R0(void);
	void I_ORL_A_R1(void);
	void I_ORL_A_R2(void);
	void I_ORL_A_R3(void);
	void I_ORL_A_R4(void);
	void I_ORL_A_R5(void);
	void I_ORL_A_R6(void);
	void I_ORL_A_R7(void);
	void I_ORL_DATA_A(void);
	void I_ORL_DATA_IMM(void);
	void I_ORL_C_BIT(void);
	void I_ORL_C_SLBIT(void);
	void I_POP_DATA(void);
	void I_PUSH_DATA(void);
	void I_RES(void); //reserved
	void I_RET(void);
	void I_RETI(void);
	void I_RL_A(void);
	void I_RLC_A(void);
	void I_RR_A(void);
	void I_RRC_A(void);
	void I_SETB_BIT(void);
	void I_SETB_C(void);
	void I_SJMP_CODE(void);
	void I_SUBB_A_AT_R0(void);
	void I_SUBB_A_AT_R1(void);
	void I_SUBB_A_DATA(void);
	void I_SUBB_A_IMM(void);
	void I_SUBB_A_R0(void);
	void I_SUBB_A_R1(void);
	void I_SUBB_A_R2(void);
	void I_SUBB_A_R3(void);
	void I_SUBB_A_R4(void);
	void I_SUBB_A_R5(void);
	void I_SUBB_A_R6(void);
	void I_SUBB_A_R7(void);
	void I_SWAP_A(void);
	void I_XCH_A_AT_R0(void);
	void I_XCH_A_AT_R1(void);
	void I_XCH_A_DATA(void);
	void I_XCH_A_R0(void);
	void I_XCH_A_R1(void);
	void I_XCH_A_R2(void);
	void I_XCH_A_R3(void);
	void I_XCH_A_R4(void);
	void I_XCH_A_R5(void);
	void I_XCH_A_R6(void);
	void I_XCH_A_R7(void);
	void I_XCHD_A_AT_R0(void);
	void I_XCHD_A_AT_R1(void);
	void I_XRL_A_AT_R0(void);
	void I_XRL_A_AT_R1(void);
	void I_XRL_A_DATA(void);
	void I_XRL_A_IMM(void);
	void I_XRL_A_R0(void);
	void I_XRL_A_R1(void);
	void I_XRL_A_R2(void);
	void I_XRL_A_R3(void);
	void I_XRL_A_R4(void);
	void I_XRL_A_R5(void);
	void I_XRL_A_R6(void);
	void I_XRL_A_R7(void);
	void I_XRL_DATA_A(void);
	void I_XRL_DATA_IMM(void);

public:
	//set a value in data memory
	//void SetDataMem(unsigned short addr, unsigned char value);
	//get a value from data memory
	//unsigned char GetDataMem(unsigned short addr);
	//set instruction Mem Pointer
	void SetInstrMemPtr(void* ptr);
	//set ROM length
	void SetROMLen(unsigned long len);
	//set instruction pointer
	void SetInstrPtr(unsigned short myPtr);
	//get instruction Pointer
	unsigned short GetInstrPtr();
private:
	//set a value in instruction memory
	//void SetInstrMem(unsigned short addr, unsigned char value); //for testing only
	//get a value from instruction memory
	unsigned char GetInstrMem(unsigned short addr);
	//get/set io-area
	//void SetIOArea(unsigned char bit, bool value);
	//bool GetIOArea(unsigned char bit); 

};
}
#endif
