// Floppy drive
// floppy.h

#ifndef __XATREMU_FLOPPY_REAL__
#define __XATREMU_FLOPPY_REAL__

#ifdef WITH_CAPS
#include "xatremu_caps.h"
#endif

#include "rommgmt.h"
#include "cpu8040.h"
#include "serial_real.h"
#include "wd1772_real.h"

namespace xatremu
{
class FloppyDrive
{
public:
	FloppyDrive(char * romName);
	virtual ~FloppyDrive();

	virtual bool SetImage(char * imageName);
	virtual void EjectImage();
	virtual void SetTo288RPM(bool is288RPM);
	virtual void SetIntLineAtari(bool intLine);
	virtual void SerialByteFromAtari(unsigned char myByte);
	virtual bool ReadyForNextInByte();
	virtual unsigned char SerialByteToAtari();
	virtual bool SerialByteForAtariAvailable();
	virtual void RunCPUOneScanline();
	virtual void RunCPUForCycles(unsigned int numOfCycles);
	virtual void SetDriveNumber(unsigned char DriveNo);
	virtual void SetSIOSpeed(unsigned char Speed);
	virtual void SetWriteProtect(unsigned char WriteProtected);
	virtual unsigned char FloppyState();
protected:
	

private:
	FloppyDrive();
	friend class testCPU8040;

	CPU8040 * m_CPU8040;
	WD1772Real * m_WD1772;
	SerialReal * m_Serial;
	ROMMgmt * m_ROM;
#ifdef WITH_CAPS
	SDWORD m_CAPSImgId;
#endif
};
}
#endif
