/* interface functions */
/* interface.h */

#ifndef __XATREMU_INTERFACE__
#define __XATREMU_INTERFACE__

#define XATREMU_DRIVEFLAVOUROFF 0
#define XATREMU_DRIVEFLAVOURXF551 1
#define XATREMU_DRIVEFLAVOURXF551_288RPM 2

#ifdef __cplusplus
extern "C" {
#endif
	/* init routine */
	extern char XATREMU_Init(void);
	/* freeing resources */
	extern void XATREMU_Free(void);
	/* set ROM name */
	extern void XATREMU_SetXF551ROMName(char * ROMName);
	/* set drive flavour (off, xf551 etc.) */
	extern void XATREMU_SetDrive(unsigned char DriveNo, unsigned char DriveFlavour);
	/* load an image */
	extern unsigned char XATREMU_SetImage(unsigned char DriveNo, char * ImageName);
	/* eject an image */
	extern unsigned char XATREMU_EjectImage(unsigned char DriveNo);
	/* reflects status of INT line of Atari computer */
	extern void XATREMU_SetIntLineAtari(unsigned char IntLine);
	/* byte from Atari SIO */
	extern void XATREMU_SerialByteFromAtari(unsigned char AtariByte);
	/* byte from Atari SIO processed? */
	extern unsigned char XATREMU_ReadyForNextByteFromAtari(void);
	/* byte to Atari SIO */
	extern unsigned char XATREMU_SerialByteToAtari(void);
	/* byte for Atari SIO available? */
	extern unsigned char XATREMU_SerialByteForAtariAvailable(void);
	/* run for one scanline */
	extern void XATREMU_RunFloppiesOneScanline(void);
	/* run for a number of cycles */
	extern void XATREMU_RunFloppiesForCycles(unsigned int numOfCycles);
	/* value of AUDF3 */
	extern void XATREMU_SIOSpeed(unsigned char Speed);
	/* set write protect status */
	extern void XATREMU_SetWriteProtect(unsigned char DriveNo, unsigned char WriteProtected);
	/* get floppy state */
	/* 0 - off, 1 - read, 2 - write, 3 - motor on */
	extern unsigned char XATREMU_FloppyState(unsigned char DriveNo);
#ifdef __cplusplus
}
#endif

#endif
