//test main routine
//main_test_real.c

#include <stdio.h>
#include <stdlib.h>
#include "cpu8040.h"
#include "serial_real.h"
#include "wd1772_real.h"
#include "rommgmt.h"

using namespace xatremu;

int main(int argc, char **argv){
	if (argc <= 2){
		printf("Usage: xatremu_test_real xf551_rom atr_image\n");
		return 10;
	}
	ROMMgmt myROM;
	CPU8040 myCPU8040;
	WD1772Real myWD1772;
	SerialReal mySerial;
	mySerial.SetCPU(&myCPU8040);
	myWD1772.SetCPU(&myCPU8040);
	myCPU8040.SetSerial(&mySerial);
	myCPU8040.SetWD1772(&myWD1772);
	if (myROM.LoadData(argv[1]) == 0) return 20;
	if (myWD1772.SetImage(argv[2]) == false) return 20;
	myCPU8040.SetInstrMemPtr(myROM.GetDataPtr());
        myCPU8040.SetROMLen(myROM.GetDataLen());
	myCPU8040.ResetCPU();
	mySerial.ResetSerial();
	myWD1772.ResetWD1772();
	for(long int loop = 0; loop < 312*50*10;++loop){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SetIntLineAtari(false);
	myCPU8040.RunCPUForCycles(80);
	mySerial.SerialByteFromAtari(0x31);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SerialByteFromAtari(0x52);
	myCPU8040.RunCPUForCycles(8);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SerialByteFromAtari(0x00);
	myCPU8040.RunCPUForCycles(8);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SerialByteFromAtari(0x01);
	myCPU8040.RunCPUForCycles(8);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SerialByteFromAtari(0x84);
	myCPU8040.RunCPUForCycles(8);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SetIntLineAtari(true);
       	for(long int loop = 0; loop < 312*50*10;++loop){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SetIntLineAtari(false);
	myCPU8040.RunCPUForCycles(80);
	mySerial.SerialByteFromAtari(0x31);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SerialByteFromAtari(0x52);
	myCPU8040.RunCPUForCycles(8);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SerialByteFromAtari(0x01);
	myCPU8040.RunCPUForCycles(8);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SerialByteFromAtari(0x00);
	myCPU8040.RunCPUForCycles(8);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SerialByteFromAtari(0x84);
	myCPU8040.RunCPUForCycles(8);
	while(!mySerial.ReadyForNextInByte()){
		myCPU8040.RunCPUForCycles(534);
	};
	mySerial.SetIntLineAtari(true);
 for(long int loop = 0; loop < 312*50*25;++loop){
                myCPU8040.RunCPUForCycles(534);
        };


/*	ROMMgmt myROM;
	myROM.LoadData(argv[1]);
	CPU8040 myCPU;
	myCPU.SetInstrMemPtr(myROM.GetDataPtr());
	myCPU.SetROMLen(myROM.GetDataLen());
	myCPU.SetInstrPtr(0);
	while ((myCPU.GetInstrPtr() < myROM.GetDataLen()) && (myCPU.GetInstrPtr() < 0xFFFD)) {
		myCPU.DisAsmNextInstruction();
	};
*/
	printf("End of Test routine\n");
	return 0;
};

